#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int rc=EXIT_FAILURE;

int main(int argc,char** argv)
{
  if (argc > 1)
  {
    if (strcmp(argv[1],"-ofdos")==0) rc=fixofdos();
    else if (strcmp(argv[1],"-date")==0) rc=fixdate(--argc,argv);
    else if (strcmp(argv[1],"-snprintf")==0) rc=fixsnprf(--argc,argv);
  } else fputs("OPTIONS:  -ofdos  -date  -snprintf",stderr);
  return rc;
}

int fixofdos(void)
{
  FILE *infile,*outfile; size_t len;
  char *c,line[100],outform[]="outform.h",backup[sizeof(outform)+1];
  strcpy(backup,outform); strcat(backup,"~"); rename(outform,backup);
  if ((infile=fopen(backup,"r")) != NULL)
  {
    outfile=fopen(outform,"w");
    while(fgets(line,sizeof(line),infile))
    {
      if (strstr(line,"#define") &&
        (strstr(line," OF_WIN32") || strstr(line," OF_ALL")))
      {
        while ((c=strchr(line,'/'))) *c='*';
        len=strlen(line)-strlen("\n");
        fprintf(outfile,"/* %*.*s */\n",len,len,line);
      }
      else
        fprintf(outfile,"%s",line);
    }
    fclose(outfile); fclose(infile); rc=EXIT_SUCCESS;
  }
  return rc;
}

int fixdate(int ac,char** av)
{
  int i; FILE *fi,*fo;
  char l[100],bak[80],*d,date[]="__DATE__";
  size_t n,ds=sizeof(date)-1;
  if (ac==1)
    fputs("USAGE:  -date badfile.c  (__DATE__ -> \"I_dont_know\")",stderr);
  else
  {
    strcpy(bak,av[2]); strcat(bak,"~"); rename(av[2],bak);
    if ((fi=fopen(bak,"r")) != NULL)
    {
      fo=fopen(av[2],"w");
      while(fgets(l,sizeof(l),fi))
      {
        if ((d=strstr(l,date)))
        {
          i=(int)(d-l); n=strlen(l);
          fprintf(fo,"%*.*s\"I_dont_know\"",i,i,l);
          if (n==(i+ds))
            fputs("",fo);
          else
            fprintf(fo,"%*.*s",n-(i+ds),n-(i+ds),d+ds);
        }
        else
          fprintf(fo,"%s",l);
      }
      fclose(fo); fclose(fi); if (ac==2) remove(bak);
      rc=EXIT_SUCCESS;
    }
  }
  return rc;
}

int fixsnprf(int ac,char** av)
{
  int lineno=0; FILE *infile,*outfile;
  char line[100],backup[80],*c;
  if (ac==1)
    fputs("USAGE:  -snprintf badfile.c  (snprintf -> sprintf)",stderr);
  else
  {
    strcpy(backup,av[2]); strcat(backup,"~"); rename(av[2],backup);
    if ((infile=fopen(backup,"r")) != NULL)
    {
      outfile=fopen(av[2],"w");
      while(fgets(line,sizeof(line),infile))
      {
        if (++lineno==1)
          fprintf(outfile,
            "#define snprintf sprintf\n#define vsnprintf vsprintf\n");
        if (strstr(line,"snprintf") && ((c=strchr(line,','))))
          fprintf(outfile,
            "%*.*s%s",(int)(c-line),(int)(c-line),line,strchr(c+1,','));
        else
          fprintf(outfile,"%s",line);
      }
      fclose(outfile); fclose(infile); rc=EXIT_SUCCESS;
    }
  }
  return rc;
}
